# This file (c) Copyright 1998 - 2002 The MITRE Corporation
# 
# This file is part of the Galaxy Communicator system. It is licensed
# under the conditions described in the file LICENSE in the root 
# directory of the Galaxy Communicator system.

ifeq ($(wildcard GC_HOME.make),)
  GC_HOME_MISSING = 1
else
  include GC_HOME.make
  ifeq ($(GC_HOME),)
    GC_HOME_MISSING = 1
  endif
endif

ifdef GC_HOME_MISSING

ifneq ($(findstring all,$(MAKECMDGOALS)),all)
  MAKECMDGOALS += all
endif

$(MAKECMDGOALS):
	@echo "GC_HOME is not set. See the docs for installation instructions."
	@exit 1

else

ROOTDIR = $(GC_HOME)

TEMPLATES = $(ROOTDIR)/templates

include $(TEMPLATES)/archos.make
include $(TEMPLATES)/$(ARCHOS)/config.make

Makefile.settings.$(ARCHOS):
	@echo "Creating Makefile.settings.$(ARCHOS)"
	@cp Makefile.settings.in $@
endif
