/*
  This file (c) Copyright 1998 - 2002 The MITRE Corporation
  
  This file is part of the Galaxy Communicator system. It is licensed
  under the conditions described in the file LICENSE in the root 
  directory of the Galaxy Communicator system.
*/

/*
 * (c) Copyright 2000-2002 The MITRE Corporation (MITRE)
 *
 * Permission is hereby granted, without payment, to copy, use,
 * modify, display and distribute this software and its documentation,
 * if any, for any purpose, provided, first, that the US Government
 * and any of its agencies will not be charged any license fee and/or
 * royalties for the use of or access to said copyright software, and
 * provided further that the above copyright notice and the following
 * three paragraphs shall appear in all copies of this software,
 * including derivatives utilizing any portion of the copyright
 * software.  Use of this software constitutes acceptance of these
 * terms and conditions.
 *
 * IN NO EVENT SHALL MITRE BE LIABLE TO ANY PARTY FOR DIRECT,
 * INDIRECT,SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT
 * OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF MITRE
 * HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * MITRE SPECIFICALLY DISCLAIMS ANY EXPRESS OR IMPLIED WARRANTIES
 * INCLUDING,BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, AND
 * NON-INFRINGEMENT.
 *
 * THE SOFTWARE IS PROVIDED "AS IS."  MITRE HAS NO OBLIGATION TO
 * PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR
 * MODIFICATIONS.
 */

package org.mitre.audiogui;

import galaxy.server.MainServer;
import galaxy.server.ServerArgParser;

/**
 * This is the Galaxy Communicator server that provides a GUI interface
 * to an audio server.
 */
public class AudioGUIMainServer extends MainServer 
{
    private Controller controller = null;
  
    public AudioGUIMainServer(String[] args, String helpText) 
    {
	super(null, args, helpText);
	serverClassName = "org.mitre.audiogui.AudioGUIServer";
	controller = new Controller(this);
    }

    public Controller getController() 
    {
	return controller;
    }

    public static void main(String[] args) 
    {
	String helpText  = "-no_gui      Starts server without enabling the controller GUI.\n" +
	    "-no_keypad   Starts the server without enabling the keypad GUI.\n" +
	    "-timeout_sec When waiting for a reply from the audio server in response\n" +
	    "             to a  configuration change, wait this many seconds before\n" +
	    "             giving up and reporting an error to the user. If less than\n" +
	    "             or equal to zero (the default), never time out.\n" +
	    "-debug       Turns on server-specific debug messages.\n";
	AudioGUIMainServer mainServer = new AudioGUIMainServer(args, helpText);
	mainServer.start();
    }
}
