/*
  This file (c) Copyright 1998 - 2002 The MITRE Corporation
  
  This file is part of the Galaxy Communicator system. It is licensed
  under the conditions described in the file LICENSE in the root 
  directory of the Galaxy Communicator system.
*/

/*
 * (c) Copyright 2000-2002 The MITRE Corporation (MITRE)
 *
 * Permission is hereby granted, without payment, to copy, use,
 * modify, display and distribute this software and its documentation,
 * if any, for any purpose, provided, first, that the US Government
 * and any of its agencies will not be charged any license fee and/or
 * royalties for the use of or access to said copyright software, and
 * provided further that the above copyright notice and the following
 * three paragraphs shall appear in all copies of this software,
 * including derivatives utilizing any portion of the copyright
 * software.  Use of this software constitutes acceptance of these
 * terms and conditions.
 *
 * IN NO EVENT SHALL MITRE BE LIABLE TO ANY PARTY FOR DIRECT,
 * INDIRECT,SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT
 * OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF MITRE
 * HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * MITRE SPECIFICALLY DISCLAIMS ANY EXPRESS OR IMPLIED WARRANTIES
 * INCLUDING,BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, AND
 * NON-INFRINGEMENT.
 *
 * THE SOFTWARE IS PROVIDED "AS IS."  MITRE HAS NO OBLIGATION TO
 * PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR
 * MODIFICATIONS.
 */

package org.mitre.audiogui.event;

import org.mitre.audiogui.ControllerEvent;

/** 
 * <code>GUIEvent</code> extends {@link org.mitre.audiogui.ControllerEvent} to
 * specify id's appropriate to GUI events.
 */

public class GUIEvent extends ControllerEvent 
{
    public static final int GUI_INVISIBLE=0;
    public static final int GUI_VISIBLE=1;
    public static final int KEYPAD_INVISIBLE=2;
    public static final int KEYPAD_VISIBLE=3;
    
    public GUIEvent(Object source, int id) 
    {
	super(source,id);
    }
    
    public String toString() 
    {
	StringBuffer buffer = new StringBuffer("GUIEvent.");
	switch (id) {
	case GUI_INVISIBLE:
	    buffer.append("GUI_INVISIBLE");
	    break;
	case GUI_VISIBLE:
	    buffer.append("GUI_VISIBLE");
	    break;
	case KEYPAD_INVISIBLE:
	    buffer.append("KEYPAD_INVISIBLE");
	    break;
	case KEYPAD_VISIBLE:
	    buffer.append("KEYPAD_VISIBLE");
	    break;
	default:
	    buffer.append("Invalid id");
	}
	return buffer.toString();
    }
}
