/*
  This file (c) Copyright 1998 - 2002 The MITRE Corporation
  
  This file is part of the Galaxy Communicator system. It is licensed
  under the conditions described in the file LICENSE in the root 
  directory of the Galaxy Communicator system.
*/

/*
 * (c) Copyright 2000-2002 The MITRE Corporation (MITRE)
 *
 * Permission is hereby granted, without payment, to copy, use,
 * modify, display and distribute this software and its documentation,
 * if any, for any purpose, provided, first, that the US Government
 * and any of its agencies will not be charged any license fee and/or
 * royalties for the use of or access to said copyright software, and
 * provided further that the above copyright notice and the following
 * three paragraphs shall appear in all copies of this software,
 * including derivatives utilizing any portion of the copyright
 * software.  Use of this software constitutes acceptance of these
 * terms and conditions.
 *
 * IN NO EVENT SHALL MITRE BE LIABLE TO ANY PARTY FOR DIRECT,
 * INDIRECT,SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT
 * OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF MITRE
 * HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * MITRE SPECIFICALLY DISCLAIMS ANY EXPRESS OR IMPLIED WARRANTIES
 * INCLUDING,BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, AND
 * NON-INFRINGEMENT.
 *
 * THE SOFTWARE IS PROVIDED "AS IS."  MITRE HAS NO OBLIGATION TO
 * PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR
 * MODIFICATIONS.
 */

package org.mitre.audiogui.event;

import org.mitre.audiogui.ControllerEvent;

/** 
 * <code>KeypadEvent</code> extends {@link org.mitre.audiogui.ControllerEvent}
 * to specify id's appropriate to keypad events.
 */

public class KeypadEvent extends ControllerEvent 
{
    public static final int OFF_HOOK=0;
    public static final int ON_HOOK=1;
    public static final int TOUCHTONE_1=2;
    public static final int TOUCHTONE_2=3;
    public static final int TOUCHTONE_3=4;
    public static final int TOUCHTONE_4=5;
    public static final int TOUCHTONE_5=6;
    public static final int TOUCHTONE_6=7;
    public static final int TOUCHTONE_7=8;
    public static final int TOUCHTONE_8=9;
    public static final int TOUCHTONE_9=10;
    public static final int TOUCHTONE_STAR=11;
    public static final int TOUCHTONE_0=12;
    public static final int TOUCHTONE_HASH=13;
    
    public KeypadEvent(Object source, int id) 
    {
	super(source,id);
    }
    
    public String toString() 
    {
	StringBuffer buffer = new StringBuffer("KeypadEvent.");
	switch (id) {
	case OFF_HOOK:
	    buffer.append("OFF_HOOK");
	    break;
	case ON_HOOK:
	    buffer.append("ON_HOOK");
	    break;
	case TOUCHTONE_1:
	    buffer.append("TOUCHTONE_1");
	    break;
	case TOUCHTONE_2:
	    buffer.append("TOUCHTONE_2");
	    break;
	case TOUCHTONE_3:
	    buffer.append("TOUCHTONE_3");
	    break;
	case TOUCHTONE_4:
	    buffer.append("TOUCHTONE_4");
	    break;
	case TOUCHTONE_5:
	    buffer.append("TOUCHTONE_5");
	    break;
	case TOUCHTONE_6:
	    buffer.append("TOUCHTONE_6");
	    break;
	case TOUCHTONE_7:
	    buffer.append("TOUCHTONE_7");
	    break;
	case TOUCHTONE_8:
	    buffer.append("TOUCHTONE_8");
	    break;
	case TOUCHTONE_9:
	    buffer.append("TOUCHTONE_9");
	    break;
	case TOUCHTONE_STAR:
	    buffer.append("TOUCHTONE_STAR");
	    break;
	case TOUCHTONE_0:
	    buffer.append("TOUCHTONE_0");
	    break;
	case TOUCHTONE_HASH:
	    buffer.append("TOUCHTONE_HASH");
	    break;
	default:
	    buffer.append("Invalid id");
	}
	return buffer.toString();
    }
}
