# This file (c) Copyright 1998 - 2002 The MITRE Corporation
# 
# This file is part of the Galaxy Communicator system. It is licensed
# under the conditions described in the file LICENSE in the root 
# directory of the Galaxy Communicator system.

#######################################
#
# This section is to be used if 
# you're compiling CATS in the context
# of the Open Source Toolkit.
# If you're compiling as a standalone
# package, comment out these lines
# and follow the instructions in the 
# next section.
#
#######################################

OSTK = $(shell cd $(CATS_ROOT)/../..; /bin/pwd)

include $(OSTK)/Makefile.settings

CATS_LIBDIR = $(OSTK)/lib

CATS_BINDIR = $(OSTK_BIN)

#######################################
#
# This section is to be used if 
# you're compiling CATS as a standalone
# package. If you're compiling as a 
# standalone package, comment out the
# section above and follow the 
# instructions below.
#
#######################################

## Set GC_HOME to the root of your Galaxy Communicator distribution
## (3.3 or later should work).

# GC_HOME =

## Set the location where you want the binaries installed.

# CATS_LIBDIR = $(CATS_ROOT)/lib

## Set the location where you want the libraries installed.

# CATS_BINDIR = $(CATS_ROOT)/bin

## CATS makes use of DSP functionality provided by the Multiple Data Type
## Matrix (MDTM) library, available for download at

## http://mdtm.lyricos.org

## MDTM_INCLUDE should be the include directory for your installation
## of the MDTM package, and MDTM_LIB should be the library directory
## for your installation of the MDTM package.

# MDTM_INCLUDE =
# MDTM_LIB =

## CATS also relies on the cross-platform PortAudio audio API.
## This library is available for download at

## http://www.portaudio.com/

## While PortAudio is robust and versatile, using it on the
## individual platforms is a little complicated. See the file
## PortAudioNotes.text before you set these variables.

## PA_INCLUDE should be set to the pa_common subdirectory of
## your PortAudio installation, and PA_LIB should be the directory
## where libportaudio can be found.

# PA_INCLUDE =
# PA_LIB =

## The Computerfone is a low-cost single-line serial port 
## telephone device. We have updated MIT's support for the 
## Computerfone and added it to our Communicator-compliant server.
## Currently, due to some mysteries about serial I/O, we have
## only managed to get this working on Solaris. If you would like
## to enable Computerfone support, uncomment this line. 

# ENABLE_CFONE = 1
