# cats_core.make contains all the appropriate dependencies.

MAKEFILE = Makefile.cats

include cats_core.make

SERVER = cats

EXECDIR = $(CATS_BINDIR)/

# List subdirectories below so that OBJ subdirectories get made.
SUBDIRS = .

# List all .c files here, including those in subdirectories:
SOURCES = cats_galaxy.c pa_mixer.c

ifdef ENABLE_CFONE
  SOURCES += cf_phone_line.c
  CPPFLAGS += -DENABLE_CFONE
endif  

# Include the rules file (make variable settings and targets)
include $(TEMPLATES)/rules.make

# Include automatically generated source dependency file
ifneq ($(findstring clean,$(MAKECMDGOALS)),clean)
include $(MAKEFILE).depend
endif

# Because we need to compile thread-aware, but not allow it to
# run threads, we need to ensure that the threaded version
# of the library is forced to compile. However, 
# $(GC_HOME)/templates/targets.make doesn't allow us to 
# do that (sigh). It will contain a dependency for 
# the NON-threaded library, but not the threaded one. So.
# $(OLIB) is an internal reference to the Communicator
# Makefile templates.

$(GC_HOME)/lib/$(ARCHOS)/libGalaxy_thread$(OLIB)$(LIBEXT): force_lib_check
	cd $(GC_HOME)/src/libGalaxy; $(MAKE) thread$(subst _,-,$(OLIB))

.PHONY: force_lib_check
