/*
  This file (c) Copyright 1998 - 2002 The MITRE Corporation
  
  This file is part of the Galaxy Communicator system. It is licensed
  under the conditions described in the file LICENSE in the root 
  directory of the Galaxy Communicator system.
*/

/*
  This file (c) Copyright 2002 The MITRE Corporation
  
  This file is part of the Communicator Audio Telephony Server
  (CATS). It is licensed under the conditions described in the file
  COPYING in the root directory of the CATS distribution.
*/

#ifndef _CATS_AUDIO_FORMAT_H
#define _CATS_AUDIO_FORMAT_H

#define CATS_ENCODING_ALAW 0
#define CATS_ENCODING_PCM_SIGNED 1
#define CATS_ENCODING_PCM_UNSIGNED 2
#define CATS_ENCODING_ULAW 3

typedef struct CatsAudioFormatPrivate_str *CatsAudioFormatPrivate;
typedef struct CatsAudioFormat_str *CatsAudioFormat;

struct CatsAudioFormat_str {
  CatsAudioFormatPrivate private;
  CatsAudioFormat (*destroy)(CatsAudioFormat this);
  int (*getEncoding)(CatsAudioFormat this);
  char *(*getEncodingString)(CatsAudioFormat this);
  float (*getSampleRate)(CatsAudioFormat this);
  int (*getSampleSizeInBits)(CatsAudioFormat this);
  int (*getChannels)(CatsAudioFormat this);
  int (*getFrameSize)(CatsAudioFormat this);
  float (*getFrameRate)(CatsAudioFormat this);
  int (*isBigEndian)(CatsAudioFormat this);
  int (*matches)(CatsAudioFormat this, CatsAudioFormat format);
  char *(*getBigEndianString)(CatsAudioFormat this);
};

CatsAudioFormat CatsAudioFormat_create(int encoding, float sampleRate,
				       int sampleSizeInBits, int channels,
				       int frameSize, float frameRate,
				       int bigEndian);

#endif
