/*
  This file (c) Copyright 1998 - 2002 The MITRE Corporation
  
  This file is part of the Galaxy Communicator system. It is licensed
  under the conditions described in the file LICENSE in the root 
  directory of the Galaxy Communicator system.
*/

/*
  This file (c) Copyright 2002 The MITRE Corporation
  
  This file is part of the Communicator Audio Telephony Server
  (CATS). It is licensed under the conditions described in the file
  COPYING in the root directory of the CATS distribution.
*/

#ifndef _CATS_BUFFER_H
#define _CATS_BUFFER_H

typedef struct CatsBufferPrivate_str *CatsBufferPrivate;
typedef struct CatsBuffer_str *CatsBuffer;

CatsBuffer CatsBuffer_create(int bufferSize);

struct CatsBuffer_str {
  CatsBufferPrivate private;

  CatsBuffer (*destroy)(CatsBuffer this);
  int (*readable)(CatsBuffer this);
  char *(*read)(CatsBuffer this, int len);
  int (*write)(CatsBuffer this, char *b, int off, int len);
  void (*reset)(CatsBuffer this);
  void (*flush)(CatsBuffer this);
  int (*getBufferSize)(CatsBuffer this);
};

#endif
