/*
  This file (c) Copyright 1998 - 2002 The MITRE Corporation
  
  This file is part of the Galaxy Communicator system. It is licensed
  under the conditions described in the file LICENSE in the root 
  directory of the Galaxy Communicator system.
*/

/*
  This file (c) Copyright 2002 The MITRE Corporation
  
  This file is part of the Communicator Audio Telephony Server
  (CATS). It is licensed under the conditions described in the file
  COPYING in the root directory of the CATS distribution.
*/

#ifndef _CATS_CAPTURE_H
#define _CATS_CAPTURE_H

typedef struct CatsCapturePrivate_str *CatsCapturePrivate;
typedef struct CatsCapture_str *CatsCapture;

#include "cats_object.h"
#include "cats_controller.h"

struct CatsCapture_str {
  CatsObject object;
  CatsCapturePrivate private;
  CatsCapture (*destroy)(CatsCapture this);
  int (*open)(CatsCapture this);
  int (*start)(CatsCapture this);
  int (*stop)(CatsCapture this);
  int (*close)(CatsCapture this);
  int (*isOpen)(CatsCapture this);
  int (*isRunning)(CatsCapture this);
  int (*isActive)(CatsCapture this);
  int (*isRecordStartable)(CatsCapture this);
  int (*startRecord)(CatsCapture this);
  void (*stopRecord)(CatsCapture this);
  int (*isResendable)(CatsCapture this);
  int (*resend)(CatsCapture this);
  int (*isVADStartable)(CatsCapture this);
  int (*startVAD)(CatsCapture this);
  void (*stopVAD)(CatsCapture this);
  int (*addListener)(CatsCapture this, CatsEventListener l);
  void (*removeListener)(CatsCapture this, CatsEventListener l);
};

CatsCapture CatsCapture_create(CatsController controller);

#endif
