/*
  This file (c) Copyright 1998 - 2002 The MITRE Corporation
  
  This file is part of the Galaxy Communicator system. It is licensed
  under the conditions described in the file LICENSE in the root 
  directory of the Galaxy Communicator system.
*/

/*
  This file (c) Copyright 2002 The MITRE Corporation
  
  This file is part of the Communicator Audio Telephony Server
  (CATS). It is licensed under the conditions described in the file
  COPYING in the root directory of the CATS distribution.
*/

#ifndef _CATS_CONTROLLER_EVENT_H
#define _CATS_CONTROLLER_EVENT_H

/* Event types */

/* After the fact: either acknowledgments or announcements.
   Issued by: capture thread (consumed by controller)
              controller (consumed by other subscribers) */
#define CATS_CAPTURE_EVENT 0
/* After the fact: announcement.
   Issued by: controller (consumed by other subscribers). */
#define CATS_INITIALIZATION_EVENT 1
/* Before the fact or after. */
#define CATS_MODE_EVENT 3
/* After the fact: either acknowledgments or announcements.
   Issued by: playback thread (consumed by controller)
              controller (consumed by other subscribers) */
#define CATS_PLAYBACK_EVENT 4
/* Before the fact: everyting except VAD_STARTED, VAD_STOPPED.
   After the fact: everything else. */
#define CATS_VAD_EVENT 5

/* Capture event IDs */

#define CATS_RECORD_STARTED 0
#define CATS_RECORD_STOPPED 1
#define CATS_RESEND 2
#define CATS_CAPTURE_LINE_OPENED 3
#define CATS_CAPTURE_LINE_CLOSED 4

/* Initialization event IDs */

#define CATS_INITIALIZED 0

/* Mode event IDs */

#define CATS_BARGE_IN_DISABLED 0
#define CATS_BARGE_IN_ENABLED 1
#define CATS_DEBUG_DISABLED 2
#define CATS_DEBUG_ENABLED 3
#define CATS_HALF_DUPLEX_DISABLED 4
#define CATS_HALF_DUPLEX_ENABLED 5
#define CATS_PLAYBOX_DISABLED 6
#define CATS_PLAYBOX_ENABLED 7
#define CATS_PTT_DISABLED 8
#define CATS_PTT_ENABLED 9
#define CATS_STREAMING_DISABLED 10
#define CATS_STREAMING_ENABLED 11

/* Playback event IDs */

#define CATS_PLAYBACK_STARTED 0
#define CATS_PLAYBACK_STOPPED 1
#define CATS_BARGE_IN 2
#define CATS_PLAYBACK_LINE_OPENED 3
#define CATS_PLAYBACK_LINE_CLOSED 4

/* VAD event IDs */

#define CATS_VAD_INACTIVE 0
#define CATS_VAD_ACTIVE 1
#define CATS_VOICE_INACTIVE 2
#define CATS_VOICE_ACTIVE 3
#define CATS_MUTE_INACTIVE 4
#define CATS_MUTE_ACTIVE 5
#define CATS_VAD_STARTED 6
#define CATS_VAD_STOPPED 7

#include "cats_event.h"

#endif
