/*
  This file (c) Copyright 1998 - 2002 The MITRE Corporation
  
  This file is part of the Galaxy Communicator system. It is licensed
  under the conditions described in the file LICENSE in the root 
  directory of the Galaxy Communicator system.
*/

/*
  This file (c) Copyright 2002 The MITRE Corporation
  
  This file is part of the Communicator Audio Telephony Server
  (CATS). It is licensed under the conditions described in the file
  COPYING in the root directory of the CATS distribution.
*/

#ifndef _CATS_CONTROLLER_PARAMETERS_H
#define _CATS_CONTROLLER_PARAMETERS_H

#include "cats_audio_format.h"

#define CATS_DEFAULT_ENCODING CATS_ENCODING_PCM_SIGNED
#define CATS_DEFAULT_SAMPLE_RATE 8000
#define CATS_DEFAULT_SAMPLE_SIZE_IN_BITS 16
#define CATS_DEFAULT_CHANNELS 1

/* Operating parameter defaults */

#define CATS_DEFAULT_T_RAISE_FACTOR 0.35
#define CATS_DEFAULT_T_LOWER_FACTOR 0.05

typedef struct CatsControllerParameters_str {

  /* Mode flags. */

  int debugEnabled;
  int halfDuplexEnabled;
  int bargeInDisabled;
  int streamingDisabled;
  int playboxEnabled;
  int pttEnabled;

  /* Format flags. */
  int recordEncoding;
  float recordSampleRate;
  int recordSampleSizeInBits;
  int recordChannels;
  int recordLittleEndian;

  int playbackEncoding;
  float playbackSampleRate;
  int playbackSampleSizeInBits;
  int playbackChannels;
  int playbackLittleEndian;

  /* Operating parameters */

  float defaultVadRaiseFactor;
  float defaultVadLowerFactor;

  /* SAM 10/1/02: This should always be true pre-4.0. */
  int useBrokers;
} *CatsControllerParameters;

#endif
