/*
  This file (c) Copyright 1998 - 2002 The MITRE Corporation
  
  This file is part of the Galaxy Communicator system. It is licensed
  under the conditions described in the file LICENSE in the root 
  directory of the Galaxy Communicator system.
*/

/*
  This file (c) Copyright 2002 The MITRE Corporation
  
  This file is part of the Communicator Audio Telephony Server
  (CATS). It is licensed under the conditions described in the file
  COPYING in the root directory of the CATS distribution.
*/

#ifndef _CATS_DATA_IN_BROKER_H
#define _CATS_DATA_IN_BROKER_H

typedef struct CatsDataInBrokerPrivate_str *CatsDataInBrokerPrivate;
typedef struct CatsDataInBroker_str *CatsDataInBroker;

#include <galaxy/galaxy.h>
#include "cats_server.h"
#include "cats_audio_format.h"
#include "cats_target_data_line.h"

CatsDataInBroker CatsDataInBroker_create(CatsServer server,
					 Gal_Frame brokerFrame);

struct CatsDataInBroker_str {
  CatsDataInBrokerPrivate private;
  CatsDataInBroker (*destroy)(CatsDataInBroker this);
  CatsAudioFormat (*getAudioFormat)(CatsDataInBroker this);
  CatsTargetDataLine (*getLine)(CatsDataInBroker this);
  int (*isFinished)(CatsDataInBroker this);
};

#endif
