/*
  This file (c) Copyright 1998 - 2002 The MITRE Corporation
  
  This file is part of the Galaxy Communicator system. It is licensed
  under the conditions described in the file LICENSE in the root 
  directory of the Galaxy Communicator system.
*/

/*
  This file (c) Copyright 2002 The MITRE Corporation
  
  This file is part of the Communicator Audio Telephony Server
  (CATS). It is licensed under the conditions described in the file
  COPYING in the root directory of the CATS distribution.
*/

#include <stdlib.h>
#include "cats_event_listener.h"

static CatsEventListener CatsEventListener_destroy(CatsEventListener this);
static void *CatsEventListener_getSource(CatsEventListener this);

struct CatsEventListenerPrivate_str {
  void *source;
};

CatsEventListener CatsEventListener_create(void *source)
{
  CatsEventListener this=NULL;

  if ((this =
       (CatsEventListener)
       calloc(1,sizeof(struct CatsEventListener_str))) != NULL) {
    CatsEventListenerPrivate private;

    this->destroy = CatsEventListener_destroy;
    this->getSource = CatsEventListener_getSource;
    this->eventGenerated = NULL;

    if ((private = this->private =
         (CatsEventListenerPrivate)
	 calloc(1,sizeof(struct CatsEventListenerPrivate_str)))
        == NULL)
      return(this->destroy(this));

    private->source = source;
  }

  return this;
}

static CatsEventListener CatsEventListener_destroy(CatsEventListener this)
{
  if (this != NULL) {
    if (this->private != NULL)
      free(this->private);
    free(this);
  }
  return NULL;
}

static void *CatsEventListener_getSource(CatsEventListener this)
{
  return this->private->source;
}
