/*
  This file (c) Copyright 1998 - 2002 The MITRE Corporation
  
  This file is part of the Galaxy Communicator system. It is licensed
  under the conditions described in the file LICENSE in the root 
  directory of the Galaxy Communicator system.
*/

/*
  This file (c) Copyright 2002 The MITRE Corporation
  
  This file is part of the Communicator Audio Telephony Server
  (CATS). It is licensed under the conditions described in the file
  COPYING in the root directory of the CATS distribution.
*/

#ifndef _CATS_LOCK_OBJECT_H
#define _CATS_LOCK_OBJECT_H

typedef struct CatsLockObjectPrivate_str *CatsLockObjectPrivate;
typedef struct CatsLockObject_str *CatsLockObject;

struct CatsLockObject_str {
  CatsLockObjectPrivate private;

  CatsLockObject (*destroy)(CatsLockObject this);
  void (*lock)(CatsLockObject this);
  void (*unlock)(CatsLockObject this);
  void (*release)(CatsLockObject this);
  void (*relock)(CatsLockObject this);
  int (*isLockable)(CatsLockObject this);
  int (*isLocked)(CatsLockObject this);
  int (*isReleased)(CatsLockObject this);
  void (*notify)(CatsLockObject this);
};

CatsLockObject CatsLockObject_create(void);

#endif
