/*
  This file (c) Copyright 1998 - 2002 The MITRE Corporation
  
  This file is part of the Galaxy Communicator system. It is licensed
  under the conditions described in the file LICENSE in the root 
  directory of the Galaxy Communicator system.
*/

/*
  This file (c) Copyright 2002 The MITRE Corporation
  
  This file is part of the Communicator Audio Telephony Server
  (CATS). It is licensed under the conditions described in the file
  COPYING in the root directory of the CATS distribution.
*/

#include <stdlib.h>
#include "cats_phone_line.h"

static CatsPhoneLine CatsPhoneLine_destroy(CatsPhoneLine this);
static void *CatsPhoneLine_getSource(CatsPhoneLine this);

struct CatsPhoneLinePrivate_str {
  void *source;
};

CatsPhoneLine CatsPhoneLine_create(void *source)
{
  CatsPhoneLine this=NULL;

  if ((this =
       (CatsPhoneLine) calloc(1,sizeof(struct CatsPhoneLine_str)))
      != NULL) {
    CatsPhoneLinePrivate private;

    this->destroy = CatsPhoneLine_destroy;
    this->getSource = CatsPhoneLine_getSource;
    this->open = NULL;
    this->poll = NULL;
    this->getDTMF = NULL;
    this->disconnect = NULL;
    this->close = NULL;
    this->isOpen = NULL;
    this->isConnected = NULL;

    if ((private = this->private =
         (CatsPhoneLinePrivate)
	 calloc(1,sizeof(struct CatsPhoneLinePrivate_str)))
        == NULL)
      return(this->destroy(this));

    private->source = source;
  }

  return this;
}

static CatsPhoneLine CatsPhoneLine_destroy(CatsPhoneLine this)
{
  if (this != NULL) {
    if (this->private != NULL) {
      if (this->isOpen != NULL && this->isOpen(this) && this->close != NULL)
	this->close(this);
      free(this->private);
    }
    free(this);
  }
  return NULL;
}

static void *CatsPhoneLine_getSource(CatsPhoneLine this)
{
  return this->private->source;
}
