/*
  This file (c) Copyright 1998 - 2002 The MITRE Corporation
  
  This file is part of the Galaxy Communicator system. It is licensed
  under the conditions described in the file LICENSE in the root 
  directory of the Galaxy Communicator system.
*/

/*
  This file (c) Copyright 2002 The MITRE Corporation
  
  This file is part of the Communicator Audio Telephony Server
  (CATS). It is licensed under the conditions described in the file
  COPYING in the root directory of the CATS distribution.
*/

#ifndef _CATS_PHONE_LINE_H
#define _CATS_PHONE_LINE_H

enum pollStatus {CATS_PHONE_FAILURE, CATS_PHONE_NO_INPUT,
		 CATS_PHONE_HANGUP_RECEIVED,
		 CATS_PHONE_DTMF,
		 CATS_PHONE_ANSWERED_CALL};

typedef struct CatsPhoneLinePrivate_str *CatsPhoneLinePrivate;
typedef struct CatsPhoneLine_str *CatsPhoneLine;

#include "cats_phone_event.h"

CatsPhoneLine CatsPhoneLine_create(void *source);

struct CatsPhoneLine_str {
  CatsPhoneLinePrivate private;
  CatsPhoneLine (*destroy)(CatsPhoneLine this);
  void *(*getSource)(CatsPhoneLine this);

  /* INTERFACE METHODS */

  int (*open)(CatsPhoneLine line);
  int (*poll)(CatsPhoneLine line);
  int (*getDTMF)(CatsPhoneLine line);
  int (*getPollMsec)(CatsPhoneLine line);
  int (*disconnect)(CatsPhoneLine line);
  int (*close)(CatsPhoneLine line);
  int (*isOpen)(CatsPhoneLine line);
  int (*isConnected)(CatsPhoneLine line);
};

#endif
