/*
  This file (c) Copyright 1998 - 2002 The MITRE Corporation
  
  This file is part of the Galaxy Communicator system. It is licensed
  under the conditions described in the file LICENSE in the root 
  directory of the Galaxy Communicator system.
*/

/*
  This file (c) Copyright 2002 The MITRE Corporation
  
  This file is part of the Communicator Audio Telephony Server
  (CATS). It is licensed under the conditions described in the file
  COPYING in the root directory of the CATS distribution.
*/

#ifndef _CATS_PLAYBACK_H
#define _CATS_PLAYBACK_H

typedef struct CatsPlaybackPrivate_str *CatsPlaybackPrivate;
typedef struct CatsPlayback_str *CatsPlayback;

#include "cats_object.h"
#include "cats_controller.h"

struct CatsPlayback_str {
  CatsObject object;
  CatsPlaybackPrivate private;
  CatsPlayback (*destroy)(CatsPlayback this);
  int (*open)(CatsPlayback this);
  int (*start)(CatsPlayback this);
  int (*stop)(CatsPlayback this);
  int (*close)(CatsPlayback this);
  int (*isPlaybackStartable)(CatsPlayback this);
  int (*startPlayback)(CatsPlayback this);
  void (*stopPlayback)(CatsPlayback this);
  int (*isBargeInStartable)(CatsPlayback this);
  int (*bargeIn)(CatsPlayback this);
  int (*addListener)(CatsPlayback this, CatsEventListener l);
  void (*removeListener)(CatsPlayback this, CatsEventListener l);
};

CatsPlayback CatsPlayback_create(CatsController controller);

#endif
