/*
  This file (c) Copyright 1998 - 2002 The MITRE Corporation
  
  This file is part of the Galaxy Communicator system. It is licensed
  under the conditions described in the file LICENSE in the root 
  directory of the Galaxy Communicator system.
*/

/*
  This file (c) Copyright 2002 The MITRE Corporation
  
  This file is part of the Communicator Audio Telephony Server
  (CATS). It is licensed under the conditions described in the file
  COPYING in the root directory of the CATS distribution.
*/

#ifndef _CATS_REQUEST_QUEUE_H
#define _CATS_REQUEST_QUEUE_H

typedef struct CatsRequestQueuePrivate_str *CatsRequestQueuePrivate;
typedef struct CatsRequestQueue_str *CatsRequestQueue;

#include "cats_request.h"
#include "cats_object.h"

/* Constructor */

CatsRequestQueue CatsRequestQueue_create(void);

struct CatsRequestQueue_str {
  CatsRequestQueuePrivate private;
  CatsRequestQueue (*destroy)(CatsRequestQueue this);
  int (*add)(CatsRequestQueue this, CatsRequest request);
  int (*contains)(CatsRequestQueue this, CatsRequest request);
  int (*removeElement)(CatsRequestQueue this, CatsRequest request);
  int (*isRedundant)(CatsRequestQueue this, void *caller,
		     void (*requesterCallback)(CatsRequest),
		     CatsObject requester);
  void (*service)(CatsRequestQueue this);
};

#endif
