/*
  This file (c) Copyright 1998 - 2002 The MITRE Corporation
  
  This file is part of the Galaxy Communicator system. It is licensed
  under the conditions described in the file LICENSE in the root 
  directory of the Galaxy Communicator system.
*/

/*
  This file (c) Copyright 2002 The MITRE Corporation
  
  This file is part of the Communicator Audio Telephony Server
  (CATS). It is licensed under the conditions described in the file
  COPYING in the root directory of the CATS distribution.
*/

#ifndef _CATS_RING_BUFFER_H
#define _CATS_RING_BUFFER_H

typedef struct CatsRingBufferPrivate_str *CatsRingBufferPrivate;
typedef struct CatsRingBuffer_str *CatsRingBuffer;

struct CatsRingBuffer_str {
  CatsRingBufferPrivate private;

  CatsRingBuffer (*destroy)(CatsRingBuffer this);
  int (*readable)(CatsRingBuffer this);
  int (*read)(CatsRingBuffer this, char *b, int off, int len);
  int (*writeable)(CatsRingBuffer this);
  int (*write)(CatsRingBuffer this, char *b, int off, int len);
  void (*flush)(CatsRingBuffer this);
  int (*getBufferSize)(CatsRingBuffer this);
  void (*lock)(CatsRingBuffer this);
  void (*unlock)(CatsRingBuffer this);
  void (*release)(CatsRingBuffer this);
  void (*relock)(CatsRingBuffer this);
  int (*isLocked)(CatsRingBuffer this);
  int (*isReleased)(CatsRingBuffer this);
  void (*notify)(CatsRingBuffer this);
};

CatsRingBuffer CatsRingBuffer_create(int bufferSize);

#endif
