/*
  This file (c) Copyright 1998 - 2002 The MITRE Corporation
  
  This file is part of the Galaxy Communicator system. It is licensed
  under the conditions described in the file LICENSE in the root 
  directory of the Galaxy Communicator system.
*/

/*
  This file (c) Copyright 2002 The MITRE Corporation
  
  This file is part of the Communicator Audio Telephony Server
  (CATS). It is licensed under the conditions described in the file
  COPYING in the root directory of the CATS distribution.
*/

#ifndef _CATS_SERVER_H
#define _CATS_SERVER_H

typedef struct CatsServerPrivate_str *CatsServerPrivate;
typedef struct CatsServer_str *CatsServer;

#include <galaxy/galaxy.h>
#include "cats_object.h"
#include "cats_controller.h"
#include "cats_source_data_line.h"
#include "cats_target_data_line.h"
#include "cats_event_listener.h"
#include "cats_audio_format.h"

/* Constructor */

CatsServer CatsServer_create(CatsControllerParameters parameters,
			     void *server_data,
			     char *initial_session_id);

struct CatsServer_str {
  CatsObject object;
  CatsServerPrivate private;
  CatsServer (*destroy)(CatsServer this);
  void (*receiveAudio)(CatsServer this, Gal_Frame f);
  void (*offHook)(CatsServer this);
  void (*onHook)(CatsServer this);
  void (*touchtone)(CatsServer this, char *idString);
  void (*mute)(CatsServer this);
  void (*unmute)(CatsServer this);
  void (*startRecording)(CatsServer this);
  void (*stopRecording)(CatsServer this);
  void (*resendAudio)(CatsServer this);
  void (*queryStatus)(CatsServer this, int server_response);
  void (*setMode)(CatsServer this, Gal_Frame f);
  int (*dataInBrokersAvailable)(CatsServer this);
  CatsAudioFormat (*getBrokerAudioFormat)(CatsServer this);
  CatsSourceDataLine (*getOutBrokerLine)(CatsServer this);
  CatsTargetDataLine (*getInBrokerLine)(CatsServer this);
  void (*flushInBrokers)(CatsServer this);
  GalIO_CommStruct *(*getCommStruct)(CatsServer this);
  CatsController (*getController)(CatsServer this);
  GalSS_Environment *(*getEnvironment)(CatsServer this);
  char *(*getServerID)(CatsServer this);
  void (*shutDown)(CatsServer this);
  int (*addListener)(CatsServer this, CatsEventListener l);
  void (*removeListener)(CatsServer this, CatsEventListener l);
};

#endif
