/*
  This file (c) Copyright 1998 - 2002 The MITRE Corporation
  
  This file is part of the Galaxy Communicator system. It is licensed
  under the conditions described in the file LICENSE in the root 
  directory of the Galaxy Communicator system.
*/

/*
  This file (c) Copyright 2002 The MITRE Corporation
  
  This file is part of the Communicator Audio Telephony Server
  (CATS). It is licensed under the conditions described in the file
  COPYING in the root directory of the CATS distribution.
*/

#include <stdlib.h>
#include "cats_source_data_line.h"

static CatsSourceDataLine CatsSourceDataLine_destroy(CatsSourceDataLine this);
static void *CatsSourceDataLine_getSource(CatsSourceDataLine this);

struct CatsSourceDataLinePrivate_str {
  void *source;
};

CatsSourceDataLine CatsSourceDataLine_create(void *source)
{
  CatsSourceDataLine this=NULL;

  if ((this =
       (CatsSourceDataLine) calloc(1,sizeof(struct CatsSourceDataLine_str)))
      != NULL) {
    CatsSourceDataLinePrivate private;

    this->destroy = CatsSourceDataLine_destroy;
    this->getSource = CatsSourceDataLine_getSource;
    this->open = NULL;
    this->start = NULL;
    this->write = NULL;
    this->stop = NULL;
    this->close = NULL;
    this->drain = NULL;
    this->flush = NULL;
    this->available = NULL;
    this->isOpen = NULL;
    this->isRunning = NULL;
    this->isActive = NULL;
    this->getBufferSize = NULL;
    this->getFormat = NULL;
    this->getFramePosition = NULL;

    if ((private = this->private =
         (CatsSourceDataLinePrivate)
	 calloc(1,sizeof(struct CatsSourceDataLinePrivate_str)))
        == NULL)
      return(this->destroy(this));

    private->source = source;
  }

  return this;
}

static CatsSourceDataLine CatsSourceDataLine_destroy(CatsSourceDataLine this)
{
  if (this != NULL) {
    if (this->private != NULL) {
      if (this->isRunning != NULL && this->isRunning(this)
	  && this->stop != NULL)
	this->stop(this);
      if (this->isOpen != NULL && this->isOpen(this) && this->close != NULL)
	this->close(this);
      free(this->private);
    }
    free(this);
  }
  return NULL;
}

static void *CatsSourceDataLine_getSource(CatsSourceDataLine this)
{
  return this->private->source;
}
