/*
  This file (c) Copyright 1998 - 2002 The MITRE Corporation
  
  This file is part of the Galaxy Communicator system. It is licensed
  under the conditions described in the file LICENSE in the root 
  directory of the Galaxy Communicator system.
*/

/*
  This file (c) Copyright 2002 The MITRE Corporation
  
  This file is part of the Communicator Audio Telephony Server
  (CATS). It is licensed under the conditions described in the file
  COPYING in the root directory of the CATS distribution.
*/

#ifndef _CATS_SOURCE_DATA_LINE_H
#define _CATS_SOURCE_DATA_LINE_H

typedef struct CatsSourceDataLinePrivate_str *CatsSourceDataLinePrivate;
typedef struct CatsSourceDataLine_str *CatsSourceDataLine;

#include "cats_audio_format.h"

struct CatsSourceDataLine_str {
  CatsSourceDataLinePrivate private;
  CatsSourceDataLine (*destroy)(CatsSourceDataLine this);
  void *(*getSource)(CatsSourceDataLine this);

  /* INTERFACE METHODS */

  int (*open)(CatsSourceDataLine line, CatsAudioFormat format, int bufferSize);
  int (*start)(CatsSourceDataLine line);
  int (*write)(CatsSourceDataLine line, char *b, int off, int len);
  int (*stop)(CatsSourceDataLine line);
  int (*close)(CatsSourceDataLine line);
  void (*drain)(CatsSourceDataLine line);
  void (*flush)(CatsSourceDataLine line);
  int (*available)(CatsSourceDataLine line);
  int (*isOpen)(CatsSourceDataLine line);
  int (*isRunning)(CatsSourceDataLine line);
  int (*isActive)(CatsSourceDataLine line);
  int (*getBufferSize)(CatsSourceDataLine line);
  CatsAudioFormat (*getFormat)(CatsSourceDataLine line);
  int (*getFramePosition)(CatsSourceDataLine line);
};

CatsSourceDataLine CatsSourceDataLine_create(void *source);

#endif
