/*
  This file (c) Copyright 1998 - 2002 The MITRE Corporation
  
  This file is part of the Galaxy Communicator system. It is licensed
  under the conditions described in the file LICENSE in the root 
  directory of the Galaxy Communicator system.
*/

/*
  This file (c) Copyright 2002 The MITRE Corporation
  
  This file is part of the Communicator Audio Telephony Server
  (CATS). It is licensed under the conditions described in the file
  COPYING in the root directory of the CATS distribution.
*/

#include <stdlib.h>
#include "cats_target_data_line.h"

static CatsTargetDataLine CatsTargetDataLine_destroy(CatsTargetDataLine this);
static void *CatsTargetDataLine_getSource(CatsTargetDataLine this);

struct CatsTargetDataLinePrivate_str {
  void *source;
};

CatsTargetDataLine CatsTargetDataLine_create(void *source)
{
  CatsTargetDataLine this=NULL;

  if ((this =
       (CatsTargetDataLine) calloc(1,sizeof(struct CatsTargetDataLine_str)))
      != NULL) {
    CatsTargetDataLinePrivate private;

    this->destroy = CatsTargetDataLine_destroy;
    this->getSource = CatsTargetDataLine_getSource;
    this->open = NULL;
    this->start = NULL;
    this->read = NULL;
    this->stop = NULL;
    this->close = NULL;
    this->available = NULL;
    this->isOpen = NULL;
    this->isRunning = NULL;
    this->isActive = NULL;
    this->getBufferSize = NULL;
    this->getFormat = NULL;
    this->getFramePosition = NULL;

    if ((private = this->private =
         (CatsTargetDataLinePrivate)
	 calloc(1,sizeof(struct CatsTargetDataLinePrivate_str)))
        == NULL)
      return(this->destroy(this));

    private->source = source;
  }

  return this;
}

static CatsTargetDataLine CatsTargetDataLine_destroy(CatsTargetDataLine this)
{
  if (this != NULL) {
    if (this->private != NULL) {
      if (this->isRunning != NULL && this->isRunning(this)
	  && this->stop != NULL)
	this->stop(this);
      if (this->isOpen != NULL && this->isOpen(this) && this->close != NULL)
	this->close(this);
      free(this->private);
    }
    free(this);
  }
  return NULL;
}

static void *CatsTargetDataLine_getSource(CatsTargetDataLine this)
{
  return this->private->source;
}
