/*
  This file (c) Copyright 1998 - 2002 The MITRE Corporation
  
  This file is part of the Galaxy Communicator system. It is licensed
  under the conditions described in the file LICENSE in the root 
  directory of the Galaxy Communicator system.
*/

/*
  This file (c) Copyright 2002 The MITRE Corporation
  
  This file is part of the Communicator Audio Telephony Server
  (CATS). It is licensed under the conditions described in the file
  COPYING in the root directory of the CATS distribution.
*/

#ifndef _CATS_TARGET_DATA_LINE_H
#define _CATS_TARGET_DATA_LINE_H

typedef struct CatsTargetDataLinePrivate_str *CatsTargetDataLinePrivate;
typedef struct CatsTargetDataLine_str *CatsTargetDataLine;

#include "cats_audio_format.h"

struct CatsTargetDataLine_str {
  CatsTargetDataLinePrivate private;
  CatsTargetDataLine (*destroy)(CatsTargetDataLine this);
  void *(*getSource)(CatsTargetDataLine this);

  /* INTERFACE METHODS */

  int (*open)(CatsTargetDataLine line, CatsAudioFormat format, int bufferSize);
  int (*start)(CatsTargetDataLine line);
  int (*read)(CatsTargetDataLine line, char *b, int off, int len);
  int (*stop)(CatsTargetDataLine line);
  int (*close)(CatsTargetDataLine line);
  int (*available)(CatsTargetDataLine line);
  void (*flush)(CatsTargetDataLine line);
  int (*isOpen)(CatsTargetDataLine line);
  int (*isRunning)(CatsTargetDataLine line);
  int (*isActive)(CatsTargetDataLine line);
  int (*getBufferSize)(CatsTargetDataLine line);
  CatsAudioFormat (*getFormat)(CatsTargetDataLine line);
  int (*getFramePosition)(CatsTargetDataLine line);
};

CatsTargetDataLine CatsTargetDataLine_create(void *source);

#endif
