/*
  This file (c) Copyright 1998 - 2002 The MITRE Corporation
  
  This file is part of the Galaxy Communicator system. It is licensed
  under the conditions described in the file LICENSE in the root 
  directory of the Galaxy Communicator system.
*/

/*
  This file (c) Copyright 2002 The MITRE Corporation
  
  This file is part of the Communicator Audio Telephony Server
  (CATS). It is licensed under the conditions described in the file
  COPYING in the root directory of the CATS distribution.
*/

#include <time.h>
#include "cats_thread.h"

#ifdef WIN32
#include <windows.h>
#endif

void CatsThread_sleep(int millis, long nanos)
{
#ifdef WIN32
  /* Just in case there are extra milliseconds in the nanoseconds value. */
  millis = millis + (nanos / 1000000);

  Sleep(millis);
#else
  struct timespec ts;
  ts.tv_sec = 0;
  ts.tv_nsec = nanos + 1000000*((long)millis);
  nanosleep(&ts,NULL);
#endif
}
