/*
  This file (c) Copyright 1998 - 2002 The MITRE Corporation
  
  This file is part of the Galaxy Communicator system. It is licensed
  under the conditions described in the file LICENSE in the root 
  directory of the Galaxy Communicator system.
*/

/*
  This file (c) Copyright 2002 The MITRE Corporation
  
  This file is part of the Communicator Audio Telephony Server
  (CATS). It is licensed under the conditions described in the file
  COPYING in the root directory of the CATS distribution.
*/

#ifndef _CATS_VAD_BUFFER_H
#define _CATS_VAD_BUFFER_H

typedef struct CatsVADBufferPrivate_str *CatsVADBufferPrivate;
typedef struct CatsVADBuffer_str *CatsVADBuffer;

#include "cats_audio_format.h"

CatsVADBuffer CatsVADBuffer_create(void);

struct CatsVADBuffer_str {
  CatsVADBufferPrivate private;
  CatsVADBuffer (*destroy)(CatsVADBuffer this);
  int (*open)(CatsVADBuffer this, CatsAudioFormat sourceAudioFormat,
	      int frameSize, float thresholdRaiseFactor,
	      float thresholdLowerFactor);
  int (*write)(CatsVADBuffer this, char *b, int off, int len);
  int (*read)(CatsVADBuffer this, char *b, int off, int len);
  int (*close)(CatsVADBuffer this);
  int (*isOpen)(CatsVADBuffer this);
};

#endif
