/*
  This file (c) Copyright 1998 - 2002 The MITRE Corporation
  
  This file is part of the Galaxy Communicator system. It is licensed
  under the conditions described in the file LICENSE in the root 
  directory of the Galaxy Communicator system.
*/

/*
  This file (c) Copyright 2002 The MITRE Corporation
  
  This file is part of the Communicator Audio Telephony Server
  (CATS). It is licensed under the conditions described in the file
  COPYING in the root directory of the CATS distribution.
*/

#ifndef _CATS_VECTOR_H
#define _CATS_VECTOR_H

typedef struct CatsVectorPrivate_str *CatsVectorPrivate;
typedef struct CatsVector_str *CatsVector;

CatsVector CatsVector_create(int initialCapacity, int capacityIncrement);

struct CatsVector_str {
  CatsVectorPrivate private;
  CatsVector (*destroy)(CatsVector this);
  int (*add)(CatsVector this, void *data);
  int (*contains)(CatsVector this, void *elem);
  void *(*elementAt)(CatsVector this, int index);
  void *(*firstElement)(CatsVector this);
  void *(*remove)(CatsVector this, int index);
  int (*removeElement)(CatsVector this, void *obj);
  void *(*removeLast)(CatsVector this);
  int (*size)(CatsVector this);
  void (*lock)(CatsVector this);
  void (*unlock)(CatsVector this);
};

#endif
