/*
  This file (c) Copyright 1998 - 2002 The MITRE Corporation
  
  This file is part of the Galaxy Communicator system. It is licensed
  under the conditions described in the file LICENSE in the root 
  directory of the Galaxy Communicator system.
*/


/* Result Sets Interface */
#ifndef SQL_CRSR
#  define SQL_CRSR
  struct sql_cursor
  {
    unsigned int curocn;
    void *ptr1;
    void *ptr2;
    unsigned long magic;
  };
  typedef struct sql_cursor sql_cursor;
  typedef struct sql_cursor SQL_CURSOR;
#endif /* SQL_CRSR */

/* Thread Safety */
typedef void * sql_context;
typedef void * SQL_CONTEXT;

/* Object support */
struct sqltvn
{
  unsigned char *tvnvsn; 
  unsigned short tvnvsnl; 
  unsigned char *tvnnm;
  unsigned short tvnnml; 
  unsigned char *tvnsnm;
  unsigned short tvnsnml;
};
typedef struct sqltvn sqltvn;

struct sqladts
{
  unsigned int adtvsn; 
  unsigned short adtmode; 
  unsigned short adtnum;  
  sqltvn adttvn[1];       
};
typedef struct sqladts sqladts;

static struct sqladts sqladt = {
  1,1,0,
};

/* Binding to PL/SQL records */
struct sqltdss
{
  unsigned int tdsvsn; 
  unsigned short tdsnum; 
  unsigned char *tdsval[1]; 
};
typedef struct sqltdss sqltdss;
static struct sqltdss sqltds =
{
  1,
  0,
};

/* File name & Package Name */
struct sqlcxp
{
  unsigned short fillen;
           char  filnam[17];
};
static const struct sqlcxp sqlfpn =
{
    16,
    "ora_interface.pc"
};


static unsigned long sqlctx = 5162899;


static struct sqlexd {
   unsigned int   sqlvsn;
   unsigned int   arrsiz;
   unsigned int   iters;
   unsigned int   offset;
   unsigned short selerr;
   unsigned short sqlety;
   unsigned int   unused;
      const short *cud;
   unsigned char  *sqlest;
      const char  *stmt;
   sqladts *sqladtp;
   sqltdss *sqltdsp;
            void  **sqphsv;
   unsigned int   *sqphsl;
            int   *sqphss;
            void  **sqpind;
            int   *sqpins;
   unsigned int   *sqparm;
   unsigned int   **sqparc;
   unsigned short  *sqpadto;
   unsigned short  *sqptdso;
            void  *sqhstv[4];
   unsigned int   sqhstl[4];
            int   sqhsts[4];
            void  *sqindv[4];
            int   sqinds[4];
   unsigned int   sqharm[4];
   unsigned int   *sqharc[4];
   unsigned short  sqadto[4];
   unsigned short  sqtdso[4];
} sqlstm = {10,4};

/* Prototypes */
extern void sqlcxt (void **, unsigned long *,
                    struct sqlexd *, const struct sqlcxp *);
extern void sqlcx2t(void **, unsigned long *,
                    struct sqlexd *, const struct sqlcxp *);
extern void sqlbuft(void **, char *);
extern void sqlgs2t(void **, char *);
extern void sqlorat(void **, unsigned long *, void *);

/* Forms Interface */
static const int IAPSUCC = 0;
static const int IAPFAIL = 1403;
static const int IAPFTL  = 535;
extern void sqliem(char *, int *);

typedef struct { unsigned short len; unsigned char arr[1]; } VARCHAR;
typedef struct { unsigned short len; unsigned char arr[1]; } varchar;

/* cud (compilation unit data) array */
static const short sqlcud0[] =
{10,4130,0,0,0,
5,0,0,1,0,0,27,119,0,0,4,4,0,1,0,1,97,0,0,1,10,0,0,1,10,0,0,1,10,0,0,
36,0,0,2,0,0,32,139,0,0,0,0,0,1,0,
51,0,0,3,0,0,17,165,0,0,1,1,0,1,0,1,97,0,0,
70,0,0,3,0,0,45,182,0,0,0,0,0,1,0,
85,0,0,3,0,0,20,188,0,0,1,0,0,1,0,2,32,0,0,
104,0,0,3,0,0,14,256,0,0,1,0,0,1,0,2,32,0,0,
123,0,0,3,0,0,15,268,0,0,0,0,0,1,0,
};


/*
  The following copyright appeared on the original version of this file:
  
  (c) Copyright 1997 M.I.T.
  Permission is hereby granted, without written agreement or royalty fee, to 
  use, copy, modify, and distribute this software and its documentation for 
  any purpose, provided that the above copyright notice and the following 
  three paragraphs appear in all copies of this software.
  IN NO EVENT SHALL M.I.T. BE LIABLE TO ANY PARTY FOR DIRECT, INDIRECT, 
  SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE OF 
  THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF M.I.T. HAS BEEN ADVISED OF 
  THE POSSIBILITY OF SUCH DAMAGE.
  M.I.T. SPECIFICALLY DISCLAIMS ANY WARRANTIES INCLUDING, BUT NOT LIMITED 
  TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR 
  PURPOSE, AND NON-INFRINGEMENT.
  THE SOFTWARE IS PROVIDED ON AN "AS IS" BASIS AND M.I.T. HAS NO OBLIGATION 
  TO PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS.
*/



/* Interface to Oracle using embedded SQL
 * --------------------------------------
 *
 * Embedded SQL mixes SQL with C language statements. SQL statements
 * begin with "EXEC". This file is run thru the ProC preprocessor to
 * turn the SQL statements into calls to the Oracle C runtime library,
 * thereby generating an ora_interface.c file
 *
 * Authors: some Oracle guy, DG, Ed Hurley
 * -------
 *
 * Routines:
 * --------
 *
 *  void sql_connect(char *dbname)	Connect to database
 *  void sql_disconnect(void)		Disconnects
 *  ora_eprint(void)                    ???
 *  start_query(char *query)		Sets up current query
 *  fetch_row(char *str)		Formats next row of current query 
 *                                        into str
 *  fetch_header(char *str)
 *  int exec_imm(char *query)
 *  print_row()
 *  row_into_string(char *str)
 *  head_row_into_string(char *str)
 *  heading_into_string(int col, char *str)
 *  col_into_string(int col, char *str)
 */

#include <stdio.h>
#include <string.h>
#include "sql.h"

/* EXEC SQL INCLUDE SQLCA.H;
 */ 
/*
 * $Header: /afs/rcf/project/ai-contrib/src/cvs-master/OSTK/database/oracle_server/src/ora_interface.c,v 1.1.1.1 2002/01/03 18:41:42 sam Exp $ sqlca.h 
 */

/* Copyright (c) 1985,1986 by Oracle Corporation. */
 
/*
NAME
  SQLCA : SQL Communications Area.
FUNCTION
  Contains no code. Oracle fills in the SQLCA with status info
  during the execution of a SQL stmt.
NOTES
  **************************************************************
  ***                                                        ***
  *** This file is SOSD.  Porters must change the data types ***
  *** appropriately on their platform.  See notes/pcport.doc ***
  *** for more information.                                  ***
  ***                                                        ***
  **************************************************************

  If the symbol SQLCA_STORAGE_CLASS is defined, then the SQLCA
  will be defined to have this storage class. For example:
 
    #define SQLCA_STORAGE_CLASS extern
 
  will define the SQLCA as an extern.
 
  If the symbol SQLCA_INIT is defined, then the SQLCA will be
  statically initialized. Although this is not necessary in order
  to use the SQLCA, it is a good pgming practice not to have
  unitialized variables. However, some C compilers/OS's don't
  allow automatic variables to be init'd in this manner. Therefore,
  if you are INCLUDE'ing the SQLCA in a place where it would be
  an automatic AND your C compiler/OS doesn't allow this style
  of initialization, then SQLCA_INIT should be left undefined --
  all others can define SQLCA_INIT if they wish.

  If the symbol SQLCA_NONE is defined, then the SQLCA variable will
  not be defined at all.  The symbol SQLCA_NONE should not be defined
  in source modules that have embedded SQL.  However, source modules
  that have no embedded SQL, but need to manipulate a sqlca struct
  passed in as a parameter, can set the SQLCA_NONE symbol to avoid
  creation of an extraneous sqlca variable.
 
MODIFIED
    jbasu      12/12/94 -  Bug 217878: note this is an SOSD file
    losborne   08/11/92 -  No sqlca var if SQLCA_NONE macro set 
  Clare      12/06/84 - Ch SQLCA to not be an extern.
  Clare      10/21/85 - Add initialization.
  Bradbury   01/05/86 - Only initialize when SQLCA_INIT set
  Clare      06/12/86 - Add SQLCA_STORAGE_CLASS option.
*/
 
#ifndef SQLCA
#define SQLCA 1
 
struct   sqlca
         {
         /* ub1 */ char    sqlcaid[8];
         /* b4  */ long    sqlabc;
         /* b4  */ long    sqlcode;
         struct
           {
           /* ub2 */ unsigned short sqlerrml;
           /* ub1 */ char           sqlerrmc[70];
           } sqlerrm;
         /* ub1 */ char    sqlerrp[8];
         /* b4  */ long    sqlerrd[6];
         /* ub1 */ char    sqlwarn[8];
         /* ub1 */ char    sqlext[8];
         };

#ifndef SQLCA_NONE 
#ifdef   SQLCA_STORAGE_CLASS
SQLCA_STORAGE_CLASS struct sqlca sqlca
#else
         struct sqlca sqlca
#endif
 
#ifdef  SQLCA_INIT
         = {
         {'S', 'Q', 'L', 'C', 'A', ' ', ' ', ' '},
         sizeof(struct sqlca),
         0,
         { 0, {0}},
         {'N', 'O', 'T', ' ', 'S', 'E', 'T', ' '},
         {0, 0, 0, 0, 0, 0},
         {0, 0, 0, 0, 0, 0, 0, 0},
         {0, 0, 0, 0, 0, 0, 0, 0}
         }
#endif
         ;
#endif
 
#endif
 
/* end SQLCA */
/* EXEC SQL INCLUDE SQLDA.H;
 */ 
/*
 * $Header: /afs/rcf/project/ai-contrib/src/cvs-master/OSTK/database/oracle_server/src/ora_interface.c,v 1.1.1.1 2002/01/03 18:41:42 sam Exp $ sqlda.h 
 */

/***************************************************************
*      The SQLDA descriptor definition			       *
*--------------------------------------------------------------*
*      VAX/3B Version					       *
*                                                              *
*  Copyright (c) 1987, 1997 by Oracle Corporation                    *
***************************************************************/


/* NOTES
  **************************************************************
  ***                                                        ***
  *** This file is SOSD.  Porters must change the data types ***
  *** appropriately on their platform.  See notes/pcport.doc ***
  *** for more information.                                  ***
  ***                                                        ***
  **************************************************************
*/

/*  MODIFIED
    lvbcheng   08/15/97 -  Move sqlda protos to sqlcpr.h
    lvbcheng   06/25/97 -  Move sqlda protos to this file
    jbasu      01/29/95 -  correct typo
    jbasu      01/27/95 -  correct comment - ub2->sb2
    jbasu      12/12/94 - Bug 217878: note this is an SOSD file
    Morse      12/01/87 - undef L and S for v6 include files
    Richey     07/13/87 - change int defs to long 
    Clare      09/13/84 - Port: Ch types to match SQLLIB structs
    Clare      10/02/86 - Add ifndef SQLDA
*/

#ifndef SQLDA_
#define SQLDA_ 1
 
#ifdef T
# undef T
#endif
#ifdef F
# undef F
#endif

#ifdef S
# undef S
#endif
#ifdef L
# undef L
#endif
 
struct SQLDA {
  /* ub4    */ long	  N; /* Descriptor size in number of entries        */
  /* text** */ char	**V; /* Ptr to Arr of addresses of main variables   */
  /* ub4*   */ long	 *L; /* Ptr to Arr of lengths of buffers	    */
  /* sb2*   */ short     *T; /* Ptr to Arr of types of buffers	            */
  /* sb2**  */ short    **I; /* Ptr to Arr of addresses of indicator vars   */
  /* sb4    */ long	  F; /* Number of variables found by DESCRIBE       */
  /* text** */ char	**S; /* Ptr to Arr of variable name pointers	    */
  /* ub2*   */ short     *M; /* Ptr to Arr of max lengths of var. names     */
  /* ub2*   */ short     *C; /* Ptr to Arr of current lengths of var. names */
  /* text** */ char	**X; /* Ptr to Arr of ind. var. name pointers       */
  /* ub2*   */ short     *Y; /* Ptr to Arr of max lengths of ind. var. names */
  /* ub2*   */ short     *Z; /* Ptr to Arr of cur lengths of ind. var. names */
  };
 
typedef struct SQLDA SQLDA;
 
#endif

/* ----------------- */
/* defines for sqlda */
/* ----------------- */

#define SQLSQLDAAlloc(arg1, arg2, arg3, arg4) sqlaldt(arg1, arg2, arg3, arg4) 

#define SQLSQLDAFree(arg1, arg2) sqlclut(arg1, arg2) 





/* SAM 5/12/00: Trying to incorporate a number of bug fixes and
   comments from Henry Lu (HYL) (sealion@hrl.com). Both he and I encountered
   some memory errors in the DB wrapper which Henry believes he's
   fixed (albeit crudely). */

/* HYL via SAM 5/12/00: when sqlald() is called, it must be initialized
   with a string large enough to handle all your VARCHAR2s. MAXNAME
   controls that size. */

#define MAXNAME 1024   

int dap_alloc = 0;
SQLDA *dap = NULL;
SQLDA *bap = NULL;
extern SQLDA *sqlald();

#define MAXCOLS 256
#define COLSIZE 4000

char results[MAXCOLS][COLSIZE];
short inds[MAXCOLS];
short print_types[MAXCOLS];

int rowcount;
int printit = 1;

/*
 * Declarations of vars used in SQL statements
 *  (who knows how these scope !!)
 */
/* EXEC SQL BEGIN DECLARE SECTION; */ 

  char *dbname;
  char *query;
/* EXEC SQL END DECLARE SECTION; */ 




/************************************************************************
 * sql_connect(dbname)
 ************************************************************************/

/* HYL via SAM 5/12/00:
   sqlald() allocates space for the descriptor, which is the storage area
   where all the information for a query is stored.  In the documentation,
   this function is now called SQLSQLDAAlloc().  The second argument defines
   the storage size of a select-list name (a SELECTed table column
   value), so if you create a VARCHAR2 variable in your database table with a
   size of 200 and you set MAXNAME to 80, you're going to have
   problems.  That's why MAXNAME has to be as big as the largest size variable
   in your table.  The third argument can be set to zero, as it isn't
   being used, given the way the code is currently written. */

void sql_connect(char *dbname)
{
  int i;

  printf("Connecting to %s...",dbname);
  fflush(stdout);

  /* EXEC SQL WHENEVER SQLERROR STOP; */ 


  /* EXEC SQL CONNECT :dbname; */ 

{
  struct sqlexd sqlstm;

  sqlstm.sqlvsn = 10;
  sqlstm.arrsiz = 4;
  sqlstm.sqladtp = &sqladt;
  sqlstm.sqltdsp = &sqltds;
  sqlstm.iters = (unsigned int  )10;
  sqlstm.offset = (unsigned int  )5;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (         void  *)dbname;
  sqlstm.sqhstl[0] = (unsigned int  )0;
  sqlstm.sqhsts[0] = (         int  )0;
  sqlstm.sqindv[0] = (         void  *)0;
  sqlstm.sqinds[0] = (         int  )0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqadto[0] = (unsigned short )0;
  sqlstm.sqtdso[0] = (unsigned short )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqphss = sqlstm.sqhsts;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqpins = sqlstm.sqinds;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlstm.sqpadto = sqlstm.sqadto;
  sqlstm.sqptdso = sqlstm.sqtdso;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) exit(1);
}



  if(!dap_alloc){
    dap = sqlald(MAXCOLS,MAXNAME,80);
    bap = sqlald(0,0,0);
    dap_alloc = 1;
    for(i=0;i<dap->N;i++){
      dap->V[i] = results[i];   
      dap->I[i] = &inds[i];   
    }
  }
  printf("Connected\n");
}

/************************************************************************
 * sql_disconnect()
 ************************************************************************/
void sql_disconnect(void)
{
  if(dap != NULL) sqlclu(dap);
  /* EXEC SQL ROLLBACK RELEASE; */ 

{
  struct sqlexd sqlstm;

  sqlstm.sqlvsn = 10;
  sqlstm.arrsiz = 4;
  sqlstm.sqladtp = &sqladt;
  sqlstm.sqltdsp = &sqltds;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )36;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) exit(1);
}


  printf("Disconnected\n");
}

void ora_eprint(void)
{
  int i;
  for(i=0;i<sqlca.sqlerrm.sqlerrml;i++)
    printf("%c",sqlca.sqlerrm.sqlerrmc[i]);
  printf("\n");
  
}

/************************************************************************
 * start_query(query)
 * RETURNS: -1 error, else 1 
 ************************************************************************/
int start_query(char *query)
{
  int i;
  char scale;

  /* EXEC SQL WHENEVER SQLERROR CONTINUE; */ 


  dap->N = MAXCOLS;

  /* EXEC SQL PREPARE s2 FROM :query; */ 

{
  struct sqlexd sqlstm;

  sqlstm.sqlvsn = 10;
  sqlstm.arrsiz = 4;
  sqlstm.sqladtp = &sqladt;
  sqlstm.sqltdsp = &sqltds;
  sqlstm.stmt = "";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )51;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (         void  *)query;
  sqlstm.sqhstl[0] = (unsigned int  )0;
  sqlstm.sqhsts[0] = (         int  )0;
  sqlstm.sqindv[0] = (         void  *)0;
  sqlstm.sqinds[0] = (         int  )0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqadto[0] = (unsigned short )0;
  sqlstm.sqtdso[0] = (unsigned short )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqphss = sqlstm.sqhsts;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqpins = sqlstm.sqinds;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlstm.sqpadto = sqlstm.sqadto;
  sqlstm.sqptdso = sqlstm.sqtdso;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
}


  if(sqlca.sqlcode < 0){
    ora_eprint();
    return(-1);
  }

  /*
   * Oracle seems to require cursor declaration before
   *  DESCRIBE
   */
  /* EXEC SQL DECLARE c2 CURSOR FOR s2; */ 

  if(sqlca.sqlcode < 0){
    ora_eprint();
    return(-1);
  }


  /* EXEC SQL OPEN c2; */ 

{
  struct sqlexd sqlstm;

  sqlstm.sqlvsn = 10;
  sqlstm.arrsiz = 4;
  sqlstm.sqladtp = &sqladt;
  sqlstm.sqltdsp = &sqltds;
  sqlstm.stmt = "";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )70;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
}


  if(sqlca.sqlcode < 0){
    ora_eprint();
    return(-1);
  }

  /* EXEC SQL DESCRIBE SELECT LIST FOR s2 INTO dap; */ 

{
  struct sqlexd sqlstm;

  sqlstm.sqlvsn = 10;
  sqlstm.arrsiz = 4;
  sqlstm.sqladtp = &sqladt;
  sqlstm.sqltdsp = &sqltds;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )85;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (         void  *)dap;
  sqlstm.sqhstl[0] = (unsigned int  )0;
  sqlstm.sqhsts[0] = (         int  )0;
  sqlstm.sqindv[0] = (         void  *)0;
  sqlstm.sqinds[0] = (         int  )0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqadto[0] = (unsigned short )0;
  sqlstm.sqtdso[0] = (unsigned short )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqphss = sqlstm.sqhsts;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqpins = sqlstm.sqinds;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlstm.sqpadto = sqlstm.sqadto;
  sqlstm.sqptdso = sqlstm.sqtdso;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
}


  if(sqlca.sqlcode < 0){
    ora_eprint();
    return(-1);
  }

  /* HYL via SAM 5/12/00:
     This is not an "undocumented feature"--it is documented, though Oracle
     doesn't say why it is the way it is.
     * (HYL) Reset Number of Select-List Items (see Oracle Pro*C/C++
     * Precompiler Programmer's Guide)
     */

  /*
   * Undocumented feature; oracle seems to use the N field not
   *   the F field to do its stuff. Must set N equal to F.
   */
  dap->N = dap->F;

  /*
   * Fix up type and length.
   * HYL via SAM 5/12/00: See SQL documentation:
   * Reset Length/Datatype of Each Select-List Item
   */   
  for(i=0;i<dap->F;i++){
    print_types[i] = dap->T[i] & 0x7fff;
    if((dap->T[i] & 0x7fff) == 2){
      scale = (char)dap->L[i];
      dap->L[i] = dap->L[i] >> 8;
      if(dap->L[i] == 0) printf("no precision!!\n");
      if(scale < 0) dap->L[i] += -scale;
      dap->L[i] += 2;
      dap->T[i] = 1;
    } else {
      /* HYL via SAM 5/12/00. Added else.
	 This is a subtle, yet important thing to do. T is a pointer
	 to an array of datatype codes (VARCHAR, NUMBER, etc.
	 all have internal codes assigned to them by Oracle).  "The high bit
	 of T[i] is set to indicate the NULL/not NULL status of
	 the ith select-list item. You must always clear this bit
	 before issuing an OPEN or FETCH command", usually by using
	 the function SQLColumnNullCheck().  In the original code,
	 it's being done explicitly for NUMBER datatypes (code =
	 2), but not for non-NUMBER types.
	 I've noticed that in the sample "flights"
	 CREATE TABLE script, most of the important columns are specified
	 as NOT NULL.  As long as you do queries on those columns,
	 you're ok, but if you do queries on a column like "meal",
	 the server complains. Clearing the high bit insures that you
	 can do queries on all your columns. */
      dap->T[i] = print_types[i];
    }
  }
   
  rowcount = 0;
  
  return(1);

}

/************************************************************************
 * fetch_row(query)
 ************************************************************************/
int fetch_row(char *str)
{

  /* EXEC SQL WHENEVER SQLERROR CONTINUE; */ 


  /* EXEC SQL FETCH c2 USING DESCRIPTOR dap; */ 

{
  struct sqlexd sqlstm;

  sqlstm.sqlvsn = 10;
  sqlstm.arrsiz = 4;
  sqlstm.sqladtp = &sqladt;
  sqlstm.sqltdsp = &sqltds;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )104;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (         void  *)dap;
  sqlstm.sqhstl[0] = (unsigned int  )0;
  sqlstm.sqhsts[0] = (         int  )0;
  sqlstm.sqindv[0] = (         void  *)0;
  sqlstm.sqinds[0] = (         int  )0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqadto[0] = (unsigned short )0;
  sqlstm.sqtdso[0] = (unsigned short )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqphss = sqlstm.sqhsts;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqpins = sqlstm.sqinds;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlstm.sqpadto = sqlstm.sqadto;
  sqlstm.sqptdso = sqlstm.sqtdso;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
}



  if(sqlca.sqlcode == 0){
     row_into_string(str);
     rowcount++;
     printf("%s ",str);
     return(rowcount);
  }
  else{
     if(sqlca.sqlcode < 0){
       ora_eprint();
     }
     /* EXEC SQL CLOSE c2; */ 

{
     struct sqlexd sqlstm;

     sqlstm.sqlvsn = 10;
     sqlstm.arrsiz = 4;
     sqlstm.sqladtp = &sqladt;
     sqlstm.sqltdsp = &sqltds;
     sqlstm.iters = (unsigned int  )1;
     sqlstm.offset = (unsigned int  )123;
     sqlstm.cud = sqlcud0;
     sqlstm.sqlest = (unsigned char  *)&sqlca;
     sqlstm.sqlety = (unsigned short)0;
     sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
}


     printf("\n%d rows returned\n",rowcount);
     return(-1);
  }
}

void fetch_header(char *str)
{
  head_row_into_string(str);
}


int exec_imm(char *query)
{
  printf("Sorry exec_imm() not currently implemented\n");
  return(-1);
}

/************************************************************************
 * Stuff for printing and formatting rows. No more SQL calls.
 ************************************************************************/

#define MINWIDTH 4
#define CHA_TYPE 96
#define VARCHAR2_TYPE 1
#define INT_TYPE 2

void print_row()
{
   int i;
   int type;
   int len;
   /* HYL via SAM 5/12/00:
      The colbuf variable is used to copy table column values.
      Because of the way VARCHAR2 datatypes are created
      (see documentation), if colbuf isn't as big as VARCHAR2
      (or whichever column has the largest size,
      doesn't have to be a VARCHAR2), screwy things will happen. */
   char colbuf[MAXNAME];
   
   for(i=0;i<dap->F;i++){
     type = col_into_string(i,colbuf);
     len = strlen(colbuf);
     printf("%s",colbuf);
     printf(" ");
   }
   printf("\n");
}


void row_into_string(char *str)
{
   int i, j;
   int type;
   /* HYL via SAM 5/12/00: see comment in print_row(). */
   char colbuf[MAXNAME];
   *str = 0;

#if DEBUG
   printf("N = %d, F = %d\n",dap->N,dap->F);
#endif

   /*   strcat(str,"( "); */

   for(i=0;i<dap->N;i++){
     type = col_into_string(i,colbuf);
     switch(type){
       case VARCHAR2_TYPE:	/* format as strings */
       case CHA_TYPE:		/* format as strings */
	 strcat(str,"\"");
	 /* Go through chars one by one and change " to \" */
	 for ( j=0; j<strlen(colbuf); j++ ) {
	   if ( colbuf[j] == '"' ) strcat(str,"\\\"");
	   else strncat(str,&colbuf[j],1);
	 }
	 /* strcat(str,colbuf);	*/
	 strcat(str,"\"");	
	 break;
       case INT_TYPE:		/* format as numbers */
	 strcat(str,"\"");	
	 for(j=0;colbuf[j] == ' ';j++);
	 strcat(str,&colbuf[j]);	
	 strcat(str,"\"");	
	 break;
       case -1:
	 strcat(str,"()");	        /* format as NIL */
	 break;
       default:
	 printf("Unknown print type %d\n",type);
	 strcat(str,"()");	        /* format as NIL */
	 break;
     }
     strcat(str," ");
   }

   /*   strcat(str,")"); */
   strcat(str,"\n");

}

void head_row_into_string(char *str)
{
   int i;
   /* HYL via SAM 5/12/00:
      This value doesn't have to be MAXNAME, just as long as the value
      is larger than the length of the longest column name
      (e.g., "arrive_airport"). */
   char colbuf[MAXNAME];
   *str = 0;
   strcat(str,"( ");

   for(i=0;i<dap->F;i++){
     heading_into_string(i,colbuf);
     strcat(str,colbuf);
     strcat(str," ");
   }

   strcat(str,")");

}


void heading_into_string(int col, char *str)
{
   int j;
   int collen;
   char *colhead;
   collen = dap->C[col];
   colhead = dap->S[col];
   for(j=0;j<collen;j++)
     str[j] = colhead[j];
   str[j] = 0;
}


/*
 * Returns type (negative only if really NULL)
 * Formats into str
 */
int col_into_string(int col, char *str)
{
   int j;
   short sqltype = dap->T[col] & 0x0fff;
   short sqlnull = dap->T[col] & 0x8000;
   int sqllen = dap->L[col];
   char *sqldata = dap->V[col];

#if DEBUG
   printf("HERE %d %d\n",sqltype,sqllen);
#endif

   switch(sqltype){
     case (-CHA_TYPE):
       if(inds[col] == -1){
	 /*	  sprintf(str,""); */
	 str[0] = '\0';
	  return(-1);
       }

     case CHA_TYPE:
       if(inds[col] == -1){
	 /* 	  sprintf(str,"");*/
	 str[0] = '\0';
	  return(-1);
       }

     case VARCHAR2_TYPE:
       if(inds[col] == -1){
	 /* 	  sprintf(str,"");*/
	 str[0] = '\0';
	  return(-1);
       }

       for(j=0;j<sqllen;j++){
	  str[j] = sqldata[j];
       }
       str[j] = 0;
       break;
     default:
       printf("Cannot print type %d len = %d\n",sqltype,sqllen);
       sprintf(str,"");
   }

   return(print_types[col]);	/* saved from DESCRIBE */

}


/* 
  for Emacs...
  Local Variables:
  mode: c
  fill-column: 110
  comment-column: 80
  c-indent-level: 2
  c-continued-statement-offset: 2
  c-brace-offset: -2
  c-argdecl-indent: 2
  c-label-offset: -2
  End:
*/
