/*
  This file (c) Copyright 1998 - 2002 The MITRE Corporation
  
  This file is part of the Galaxy Communicator system. It is licensed
  under the conditions described in the file LICENSE in the root 
  directory of the Galaxy Communicator system.
*/

#ifndef __PG_INTERFACE_H__
#define __PG_INTERFACE_H__

#include <stdio.h>
#include <libpq-fe.h>


#include <string.h>
#include "galaxy/galaxy_all.h"
#include "MITRE_galaxy.h"

#define MAX_COLS 256

enum {PG_SELECT_QUERY, PG_INSERT_QUERY,
      PG_OTHER_QUERY, PG_FAILED_QUERY};

void exit_nicely(PGconn *conn);
int begin_query(char * query);
int end_query(int query_type);
void sql_connect(char *username_passwd);
void sql_disconnect();
void print_tuples();
Gal_Object build_attribute_list();
Gal_Object build_tuple_list(int index);
int get_rowcount();

#endif



