/*
  This file (c) Copyright 1998 - 2002 The MITRE Corporation
  
  This file is part of the Galaxy Communicator system. It is licensed
  under the conditions described in the file LICENSE in the root 
  directory of the Galaxy Communicator system.
*/

// $Id: CommunicatorRecognizerInterface.java,v 1.1.1.1 2002/01/03 18:41:39 sam Exp $

package org.mitre.csms.recognition;

import galaxy.lang.*;

public interface CommunicatorRecognizerInterface {

    static final String ATTRIBUTE_CHANGED_MSG = "Attribute_Changed";
    static final String INTERFERENCE_MSG = "Interference";
    static final String PHRASE_MSG = "Phrase";
    static final String RECOGNITION_EVENT_MSG = "Recognition_Event";
    static final String RESULTS_MSG = "Results";
    static final String SPEECH_STARTED_MSG = "Speech_Started";
    static final String SPEECH_STOPPED_MSG = "Speech_Stopped";
    static final String VOLUME_LIMITS_MSG = "Volume_Limits";

    static final String ATTRIBUTE_NAME_KEY = ":attribute_name";
    static final String ATTRIBUTE_VALUE_NEW_KEY = ":attribute_value_new";
    static final String ATTRIBUTE_VALUE_OLD_KEY = ":attribute_value_old";
    static final String AUDIO_SOURCE_PARAM_KEY = ":audio_source_param";
    static final String AUDIO_SAMPLES_KEY = ":audio_samples";
    static final String AUDIO_SOURCE_TYPE_KEY = ":audio_source_type";
    static final String AUTOMATIC_GAIN_KEY = ":automatic_gain";
    static final String BACKGROUND_NOISE_LEVEL_KEY = ":background_noise_level";
    static final String CONTROL_TYPE_KEY = ":control";
    static final String CURRENT_BYTE_KEY = ":current_byte";
    static final String ENERGY_FLOOR_KEY = ":energy_floor";
    static final String EVENT_NAME_KEY = ":event_name";
    static final String GRAMMAR_FILE_KEY = ":grammar_file";
    static final String GRAMMAR_TYPE_KEY = ":grammar_type";
    static final String GRAMMAR_PARAMS_KEY = ":grammar_params";
    static final String INTERFERENCE_KEY = ":interference";
    static final String LANGUAGE_MODEL_KEY = ":language_model";
    static final String N_BEST_KEY = ":n_best";
    static final String NOISE_SENSITIVITY_KEY = ":noise_sensitivity";
    static final String NUM_KEY = ":num";
    static final String NUM_SAMPLES_KEY = ":num_samples";
    static final String NOTIFY_ATTRIBUTE_CHANGES_KEY = ":notify_attribute_changes";
    static final String NOTIFY_STATUS_KEY = ":notify_status";
    static final String PAUSE_AFTER_RECOGNITION_KEY = ":pause_after_recognition";
    static final String PHONES_KEY = ":phones";
    static final String PHRASE_KEY = ":phrase";
    static final String REAL_TIME_SETTING_KEY = ":real_time_setting";
    static final String RESULTS_KEY = ":results";
    static final String SAMPLE_BYTE_SIZE_KEY = ":sample_byte_size";
    static final String SCORE_KEY = ":score";
    static final String SEND_NOTIFICIATIONS_KEY = ":send_notificiations";
    static final String SPEAKER_KEY = ":speaker";
    static final String START_END_SPEECH_KEY = ":start_end_speech";
    static final String START_TIME_KEY = ":start_time";
    static final String END_TIME_KEY = ":end_time";
    static final String SUB_LANGUAGE_MODEL_KEY = ":sub_language_model";
    static final String THRESHOLD_KEY = ":threshold";
    static final String TIME_OUT_KEY = ":time_out";
    static final String VOLUME_KEY = ":volume";
    static final String VOLUME_LIMITS_KEY = ":volume_limits";
    static final String WORDS_KEY = ":words";

    // tested
    public void serverOpReinitialize(GFrame frame);
    public GFrame serverOpConfigure(GFrame frame);
    public GFrame serverOpPause(GFrame frame);
    public GFrame serverOpResume(GFrame frame);
    // untested 

    public GFrame serverOpForcedRecognition(GFrame frame);
    public GFrame serverOpGrammarControl(GFrame frame);




}


