/*
  This file (c) Copyright 1998 - 2002 The MITRE Corporation
  
  This file is part of the Galaxy Communicator system. It is licensed
  under the conditions described in the file LICENSE in the root 
  directory of the Galaxy Communicator system.
*/

// $Id: CommunicatorSynthesizerInterface.java,v 1.1.1.1 2002/01/03 18:41:40 sam Exp $

package org.mitre.csms.synthesis;

import galaxy.lang.*;

public interface CommunicatorSynthesizerInterface {

    static final String SYNTHESIS_EVENT_MSG = "Synthesis_Event";
    static final String ATTRIBUTE_CHANGED_MSG = "Attribute_Changed";
    static final String CURRENT_BYTE_MSG = "Current_Byte";
    static final String WORD_POSITION_MSG = "Word_Position";
    static final String MARKER_REACHED_MSG = "Marker_Reached";

    static final String AUDIO_DESTINATION_TYPE_KEY = ":audio_destination_type";
    static final String AUDIO_DESTINATION_PARAM_KEY=":audio_destination_param";
    static final String AVERAGE_SPEAKING_SPEED_KEY = ":average_speaking_speed";
    static final String PHONEME_TRANSLATION_FILE_KEY=":phoneme_translation_file";
    static final String PITCH_KEY = ":pitch";
    static final String REAL_TIME_SETTING_KEY = ":real_time_setting";
    static final String VOLUME_KEY = ":volume";
    static final String MARKER_KEY = ":marker";
    static final String CURRENT_BYTE_KEY = ":current_byte";
    static final String NOTIFY_ATTRIBUTE_CHANGES_KEY = ":notify_attribute_changes";
    static final String NOTIFY_STATUS_KEY = ":notify_status";
    static final String NOTIFY_WORD_POSITION_KEY = ":notify_word_position";
    static final String TEXT_KEY = ":text";
    static final String EVENT_NAME_KEY = ":event_name";
    static final String WORD_POSITION_KEY = ":position";
    static final String WORD_KEY = ":word";
    static final String PHONE_SEQUENCE_KEY = ":phone_sequence";

    public void serverOpReinitialize(GFrame frame);
    public GFrame serverOpConfigure(GFrame frame);
    public GFrame serverOpGetVoice(GFrame frame);
    public GFrame serverOpSetVoice(GFrame frame) throws Exception;
    public GFrame serverOpPause(GFrame frame) throws Exception;
    public GFrame serverOpResume(GFrame frame) throws Exception;
    public GFrame serverOpPronunciation(GFrame frame);
    public GFrame serverOpGetWordPronunciation(GFrame frame)throws Exception;
    public GFrame serverOpRemoveWord(GFrame frame);
    public GFrame serverOpSpeak(GFrame frame) throws Exception;
}
