/*
  This file (c) Copyright 1998 - 2002 The MITRE Corporation
  
  This file is part of the Galaxy Communicator system. It is licensed
  under the conditions described in the file LICENSE in the root 
  directory of the Galaxy Communicator system.
*/

#include "audioConversion.h"


void conv16bto8b(short *buf16, int size, char *buf8)
{
   while(size--)
      *buf8++ = *buf16++ >> 8;
}


void conv8bto16b(char *buf8, int size, short *buf16)
{
   while(size--)
      *buf16++ = *buf8++ << 8;
}


void conv8Khzto16Khz_16b(short *buf8, int size, short *initial, short *buf16)
{
   do
   {
      *buf16++ = (*buf8 + *initial) >> 1;
      *initial = *buf8;
      *buf16++ = *buf8++;
   } while(--size);
}


void conv8Khzto16Khz_8b(char *buf8, int size, char *initial, char *buf16)
{
   do
   {
      *buf16++ = (*buf8 + *initial) >> 1;
      *initial = *buf8;
      *buf16++ = *buf8++;
   } while(--size);
}


void conv16Khzto8Khz_16b(short *buf16, int size, short *buf8)
{
   int sample;

   while(size > 1)
   {
      sample = *buf16++;
      sample += *buf16++;
      
      *buf8++ = sample/2;
      size -= 2;
   }

   if(size == 1)
      *buf8 = *buf16;
}


void conv16Khzto8Khz_8b(char *buf16, int size, char *buf8)
{
   int sample;

   while(size > 1)
   {
      sample = *buf16++;
      sample += *buf16++;
      
      *buf8++ = sample/2;
      size -= 2;
   }

   if(size == 1)
      *buf8 = *buf16;
}
