# This file (c) Copyright 1998 - 2002 The MITRE Corporation
# 
# This file is part of the Galaxy Communicator system. It is licensed
# under the conditions described in the file LICENSE in the root 
# directory of the Galaxy Communicator system.

def MungeTime(t_int):
    s = str(t_int)
    return s[:-2] + ":" + s[-2:]

Alternative(

FrameMap(
  If(Or(Eq(frame_name, statement),
	Eq(frame_name, identify),
	Eq(frame_name, question))),
  Map(Apply(statement_name, frame_name), speech_act),
  Map(Apply(any, topic), self),
  Map(Apply(any, pred), self)
),

FrameMap(
  If(Eq(frame_name, flight)),
  Map(frame_name, frame_name),
  Map(Apply(flight, pred), self)
),

FrameMap(
  If(Eq(frame_name, when)),
  Map(Apply(time, pred), departure_time)
),

FrameMap(
  If(Eq(frame_name, departure_time)),
  Map(Apply(any, topic), departure_time),
  Map(Apply(time, pred), self)
),

FrameMap(
  If(Eq(frame_name, source)),
  Add(frame_name, "flight"),
  Map(Apply(any, topic), source)
),

FrameMap(
  If(Eq(frame_name, destination)),
  Add(frame_name, "flight"),
  Map(Apply(any, topic), destination)
),

FrameMap(
  If(Eq(frame_name, city)),
  Map(Apply(city_name, name), self)
),

FrameMap(
  If(Eq(frame_name, around)),
  Add(qualifier, "around"),
  Map(topic, self), 
  name = time
),

FrameMap(
  If(Exists(military)),
  Map(Apply(time_munger, military), value),
  Add(xm, "military"),
  name = military_time
),

FrameMap(
  If(Eq(frame_name, time)),
  Map(frame_name, frame_name),
  Map(hour, hour),
  Map(minutes, minutes),
  Map(xm, xm),
  Map(Apply(military_time, self))
),

FunctionMap(fn = MungeTime, name = time_munger),

FrameMap(
  If(And(Eq(frame_name, flight_specifier),
	 Or(Eq(topic, "latest"),
	    Eq(topic, "last")))),
  Add(Path(departure_time, frame_name), "time"),
  Add(Path(departure_time, value), "MAX")
),

FrameMap(
  If(And(Eq(frame_name, flight_specifier),
	 Eq(topic, "non stop"))),
  Map(topic, flight_specifier)
),

FrameMap(
  If(Eq(frame_name, serve_meal)),
  Map(Apply(meal, topic), serve_meal)
),

FrameMap(
  Map(Apply(meal_name, name), self),
  name = meal
),

FrameMap(
  If(Eq(frame_name, airline)),
  Map(Apply(airline, topic), airline)
),

FrameMap(
  If(Eq(frame_name, flight_number)),
  Map(topic, flight_number)
)

)

ValueMap(
  VMap(american, "AA"),
  name = airline
)

ValueMap(
  VMap(meal, "*"),
  VMap(breakfast, "B"),
  name = meal_name
)

ValueMap(
  VMap(boston, BOS),
  VMap(denver, DEN),
  VMap(chicago, ORD),
  VMap(dallas, DFW),
  name = city_name
)

ValueMap(
  VMap(statement, implied_identify),
  VMap(identify, identify),
  VMap(question, question),
  name = statement_name
)

FrameMap(
  If(Or(Eq(value, MAX),
	Eq(value, MIN))),
  Add(Path(parent, scopal), 1)
)

Alternative(
FrameMap(
  If(Or(Compare(conjuncts, 2, operator = less_than, compare_type = length)),
     Every(conjuncts, Not(Exists(scopal)))),
  Map(conjuncts, self),
  name = scopal_promote
),

FrameMap(
  ForEach(conjuncts, Delete(scopal)),
  name = scopal_promote
)
)
