/*
  This file (c) Copyright 1998 - 2002 The MITRE Corporation
  
  This file is part of the Galaxy Communicator system. It is licensed
  under the conditions described in the file LICENSE in the root 
  directory of the Galaxy Communicator system.
*/

package org.mitre.galaxycommunicator.visualizer;

import galaxy.lang.GFrame;
import java.util.List;
import java.util.ArrayList;

/**
 * Encapsulates the information used to create menu items that send frames
 * to the Hub.
 *
 * @author Steve Wohlever, MITRE Corporation, wohlever@mitre.org
 */
public class FrameMenuItem
{
    /** The name of the menu item (as it appears in the UI). */
    private String name;

    /** The frame that is sent to the Hub when this menu item is selected. */
    private GFrame frame;

    /** Collection of frame variables. */
    private List variables;
    
    public FrameMenuItem(String name, GFrame frame)
    {
	this.name = name;
	this.frame = frame;
	variables = new ArrayList();
    }
    
    public String getName()
    {
	return name;
    }
    
    public GFrame getFrame()
    {
	return frame;
    }
    
    public void addVariable(FrameVariable variable)
    {
	variables.add(variable);
    }
    
    public List getVariables()
    {
	return variables;
    } 
}
