/*
  This file (c) Copyright 1998 - 2002 The MITRE Corporation
  
  This file is part of the Galaxy Communicator system. It is licensed
  under the conditions described in the file LICENSE in the root 
  directory of the Galaxy Communicator system.
*/

package org.mitre.galaxycommunicator.visualizer;

/** 
 * Encapsulates a frame variable.
 *
 * @author Steve Wohlever, MITRE Corporation, wohlever@mitre.org
 */
public class FrameVariable
{
    /** The frame key of this variable. */
    private String frameKey;

    /** The variable name. */
    private String variableName;

    /** The variable type as defined in galaxy.lang.GalaxyObject. */
    private int variableType;
    
    public FrameVariable(String frameKey, String variableName, 
			 int variableType)
    {
	this.frameKey = frameKey;
	this.variableName = variableName;
	this.variableType = variableType;
    }
    
    public String getFrameKey()
    {
	return frameKey;
    }
    
    public String getVariableName()
    {
	return variableName;
    }
    
    public int getVariableType()
    {
	return variableType;
    } 
}
